var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { ParticleCloud, } from './ParticleCloud';
var CloudSwitch = /** @class */ (function () {
    function CloudSwitch(particleDevice) {
        this.particleDevice = particleDevice;
    }
    CloudSwitch.createCloudSwitchForId = function (deviceId, accessToken) {
        return __awaiter(this, void 0, void 0, function () {
            var particleCloud, cloudSwitchDevice;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        particleCloud = new ParticleCloud(accessToken);
                        return [4 /*yield*/, particleCloud.getDevice(deviceId)];
                    case 1:
                        cloudSwitchDevice = _a.sent();
                        return [2 /*return*/, new CloudSwitch(cloudSwitchDevice)];
                }
            });
        });
    };
    CloudSwitch.createCloudSwitchWithName = function (name, accessToken) {
        return __awaiter(this, void 0, void 0, function () {
            var particleCloud, devices, cloudSwitchDevice;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        particleCloud = new ParticleCloud(accessToken);
                        return [4 /*yield*/, particleCloud.listDevices()];
                    case 1:
                        devices = _a.sent();
                        cloudSwitchDevice = devices.find(function (device) { return device.name === name; });
                        if (cloudSwitchDevice === undefined) {
                            throw new Error("Could not find device named: " + name);
                        }
                        return [2 /*return*/, new CloudSwitch(cloudSwitchDevice)];
                }
            });
        });
    };
    CloudSwitch.createCloudSwitch = function (accessToken) {
        return __awaiter(this, void 0, void 0, function () {
            var particleCloud, devices, cloudSwitchDevice;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        particleCloud = new ParticleCloud(accessToken);
                        return [4 /*yield*/, particleCloud.listDevices()];
                    case 1:
                        devices = _a.sent();
                        cloudSwitchDevice = devices.find(function (device) { return device.online && 'switchConfig' in device.variables; });
                        if (cloudSwitchDevice === undefined) {
                            throw new Error('Could not find online CloudSwitch device');
                        }
                        return [2 /*return*/, new CloudSwitch(cloudSwitchDevice)];
                }
            });
        });
    };
    CloudSwitch.prototype.name = function () {
        return this.particleDevice.name;
    };
    CloudSwitch.prototype.id = function () {
        return this.particleDevice.id;
    };
    CloudSwitch.prototype.isOnline = function () {
        return this.particleDevice.online;
    };
    CloudSwitch.prototype.onSwitchConfigChanged = function (handler) {
        return __awaiter(this, void 0, void 0, function () {
            var _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        if (!(handler !== undefined)) return [3 /*break*/, 3];
                        if (!(this.configChangedEventStream === undefined)) return [3 /*break*/, 2];
                        _a = this;
                        return [4 /*yield*/, this.particleDevice.getEventStream('switchConfigChanged')];
                    case 1:
                        _a.configChangedEventStream =
                            _b.sent();
                        this.configChangedEventStream.onEvent(function (event) {
                            handler(parseInt(event.data));
                        });
                        _b.label = 2;
                    case 2: return [3 /*break*/, 4];
                    case 3:
                        if (this.configChangedEventStream !== undefined) {
                            this.configChangedEventStream.abort();
                        }
                        _b.label = 4;
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    CloudSwitch.prototype.onSwitchStateChanged = function (handler) {
        return __awaiter(this, void 0, void 0, function () {
            var _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        if (!(handler !== undefined)) return [3 /*break*/, 3];
                        if (!(this.configChangedEventStream === undefined)) return [3 /*break*/, 2];
                        _a = this;
                        return [4 /*yield*/, this.particleDevice.getEventStream('switchStateChanged')];
                    case 1:
                        _a.stateChangedEventStream = _b.sent();
                        this.stateChangedEventStream.onEvent(function (event) {
                            var switchIndex = parseInt(event.data);
                            var switchState = event.data.charAt(2) === '1';
                            handler(switchIndex, switchState);
                        });
                        _b.label = 2;
                    case 2: return [3 /*break*/, 4];
                    case 3:
                        if (this.configChangedEventStream !== undefined) {
                            this.configChangedEventStream.abort();
                        }
                        _b.label = 4;
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    CloudSwitch.prototype.setSwitchConfig = function (switchConfig) {
        return __awaiter(this, void 0, void 0, function () {
            var switchConfigStr, result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        switchConfigStr = JSON.stringify(switchConfig);
                        return [4 /*yield*/, this.particleDevice.callFunction('setSwitchConfig', switchConfigStr)];
                    case 1:
                        result = _a.sent();
                        return [2 /*return*/, result];
                }
            });
        });
    };
    CloudSwitch.prototype.getSwitchConfig = function () {
        return __awaiter(this, void 0, void 0, function () {
            var switchConfigStr, switchConfig;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.particleDevice.getVariable('switchConfig')];
                    case 1:
                        switchConfigStr = _a.sent();
                        switchConfig = JSON.parse(switchConfigStr);
                        return [2 /*return*/, switchConfig];
                }
            });
        });
    };
    CloudSwitch.prototype.switchStates = function () {
        return __awaiter(this, void 0, void 0, function () {
            var stateStr, switchState;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.particleDevice.getVariable('switchState')];
                    case 1:
                        stateStr = _a.sent();
                        switchState = stateStr.split(' ').map(function (s) {
                            return s === '1';
                        });
                        return [2 /*return*/, switchState];
                }
            });
        });
    };
    CloudSwitch.prototype.switchStateFromResult = function (result, switchIndex) {
        switch (result) {
            case 0:
                return false;
            case 1:
                return true;
            default:
                throw new Error("Invalid switchIndex: " + switchIndex);
        }
    };
    CloudSwitch.prototype.toggleSwitch = function (switchIndex) {
        return __awaiter(this, void 0, void 0, function () {
            var result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.particleDevice.callFunction('toggleSwitch', "" + switchIndex)];
                    case 1:
                        result = _a.sent();
                        return [2 /*return*/, this.switchStateFromResult(result, switchIndex)];
                }
            });
        });
    };
    CloudSwitch.prototype.turnOnSwitch = function (switchIndex) {
        return __awaiter(this, void 0, void 0, function () {
            var result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.particleDevice.callFunction('turnOnSwitch', "" + switchIndex)];
                    case 1:
                        result = _a.sent();
                        return [2 /*return*/, this.switchStateFromResult(result, switchIndex)];
                }
            });
        });
    };
    CloudSwitch.prototype.turnOffSwitch = function (switchIndex) {
        return __awaiter(this, void 0, void 0, function () {
            var result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.particleDevice.callFunction('turnOffSwitch', "" + switchIndex)];
                    case 1:
                        result = _a.sent();
                        return [2 /*return*/, this.switchStateFromResult(result, switchIndex)];
                }
            });
        });
    };
    CloudSwitch.prototype.getSwitchState = function (switchIndex) {
        return __awaiter(this, void 0, void 0, function () {
            var result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.particleDevice.callFunction('getSwitchState', "" + switchIndex)];
                    case 1:
                        result = _a.sent();
                        return [2 /*return*/, this.switchStateFromResult(result, switchIndex)];
                }
            });
        });
    };
    CloudSwitch.prototype.setSwitchState = function (switchIndex, isOn) {
        return __awaiter(this, void 0, void 0, function () {
            var result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.particleDevice.callFunction('setSwitchState', switchIndex + " " + (isOn ? '1' : '0'))];
                    case 1:
                        result = _a.sent();
                        return [2 /*return*/, this.switchStateFromResult(result, switchIndex)];
                }
            });
        });
    };
    return CloudSwitch;
}());
export { CloudSwitch };
