var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import Particle from 'particle-api-js';
var particle = new Particle();
var ParticleDeviceImp = /** @class */ (function () {
    function ParticleDeviceImp(device, particleCloud) {
        this.particleCloud = particleCloud;
        this.id = '';
        this.name = '';
        this.online = false;
        this.last_heard = new Date(0);
        this.functions = [];
        this.variables = {};
        Object.assign(this, device);
    }
    ParticleDeviceImp.prototype.toString = function () {
        return this.name + " (" + this.id + ")";
    };
    ParticleDeviceImp.prototype.callFunction = function (name, argument) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.particleCloud.callFunction(this.id, name, argument)];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    ParticleDeviceImp.prototype.getVariable = function (name) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.particleCloud.getVariable(this.id, name)];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    ParticleDeviceImp.prototype.getEventStream = function (name) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.particleCloud.getEventStream(this.id, name)];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    return ParticleDeviceImp;
}());
var ParticleEventStreamImp = /** @class */ (function () {
    function ParticleEventStreamImp(eventStream) {
        this.eventStream = eventStream;
    }
    ParticleEventStreamImp.prototype.abort = function () {
        this.eventStream.abort();
    };
    ParticleEventStreamImp.prototype.onEvent = function (handler) {
        this.eventStream.on('event', handler);
        return this;
    };
    ParticleEventStreamImp.prototype.onError = function (handler) {
        this.eventStream.on('error', handler);
        return this;
    };
    ParticleEventStreamImp.prototype.onDisconnect = function (handler) {
        this.eventStream.on('disconnect', handler);
        return this;
    };
    ParticleEventStreamImp.prototype.onReconnect = function (handler) {
        this.eventStream.on('reconnect', handler);
        return this;
    };
    ParticleEventStreamImp.prototype.onReconnectSuccess = function (handler) {
        this.eventStream.on('reconnect-success', handler);
        return this;
    };
    ParticleEventStreamImp.prototype.onReconnectError = function (handler) {
        this.eventStream.on('reconnect-error', handler);
        return this;
    };
    return ParticleEventStreamImp;
}());
var ParticleCloud = /** @class */ (function () {
    function ParticleCloud(aceessToken) {
        this.accessToken = aceessToken;
    }
    ParticleCloud.prototype.listDevices = function () {
        return __awaiter(this, void 0, void 0, function () {
            var response;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, particle.listDevices({
                            auth: this.accessToken,
                        })];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, response.body.map(function (dev) {
                                return new ParticleDeviceImp(dev, _this);
                            })];
                }
            });
        });
    };
    ParticleCloud.prototype.getDevice = function (deviceId) {
        return __awaiter(this, void 0, void 0, function () {
            var response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, particle.getDevice({
                            deviceId: deviceId,
                            auth: this.accessToken,
                        })];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, new ParticleDeviceImp(response.body, this)];
                }
            });
        });
    };
    ParticleCloud.prototype.callFunction = function (deviceId, name, argument) {
        return __awaiter(this, void 0, void 0, function () {
            var response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, particle.callFunction({
                            deviceId: deviceId,
                            name: name,
                            argument: argument,
                            auth: this.accessToken,
                        })];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, response.body.return_value];
                }
            });
        });
    };
    ParticleCloud.prototype.getVariable = function (deviceId, name) {
        return __awaiter(this, void 0, void 0, function () {
            var response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, particle.getVariable({
                            deviceId: deviceId,
                            name: name,
                            auth: this.accessToken,
                        })];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, response.body.result];
                }
            });
        });
    };
    ParticleCloud.prototype.getEventStream = function (deviceID, name) {
        return __awaiter(this, void 0, void 0, function () {
            var response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, particle.getEventStream({
                            deviceID: deviceID,
                            name: name,
                            auth: this.accessToken,
                        })];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, new ParticleEventStreamImp(response)];
                }
            });
        });
    };
    return ParticleCloud;
}());
export { ParticleCloud };
